package kr.bit.controller;

import java.io.IOException;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kr.bit.model.MemberDAO;
import kr.bit.model.MemberVO;

public class MemberListController implements Controller {

	@Override
	public String requestHandler(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		
		// POJP가 해야할 일
		// 1. model과 연동
		MemberDAO dao = new MemberDAO();
		List<MemberVO> list = dao.memberList();
		
		// 2. 객체 바인딩
		request.setAttribute("list", list);		// 객체 바인딩
		// list를 member/memberList.jsp 로 전달해줘야 함.
		
		// 3. 다음 페이지 정보를 FrontController에게 넘겨주는 일
		// 다음 페이지 (View Page 정보)
		// return "/WEB-INF/member/memberList.jsp";
		return "memberList";
	}
}
