package kr.bit.frontController;

import java.util.HashMap;

import kr.bit.controller.Controller;
import kr.bit.controller.MemberContentController;
import kr.bit.controller.MemberDeleteController;
import kr.bit.controller.MemberInsertController;
import kr.bit.controller.MemberListController;
import kr.bit.controller.MemberRegisterController;
import kr.bit.controller.MemberUpdateController;

public class HandlerMapping {
	private HashMap<String, Controller> mappings;
	
	public HandlerMapping() {
		mappings = new HashMap<String, Controller>();
		mappings.put("/memberList.do",		new MemberListController());
		mappings.put("/memberInsert.do",	new MemberInsertController());
		mappings.put("/memberRegister.do",	new MemberRegisterController());
		mappings.put("/memberContent.do",	new MemberContentController());
		mappings.put("/memberUpdate.do",	new MemberUpdateController());
		mappings.put("/memberDelete.do",	new MemberDeleteController());
	}
	
	public Controller getController(String key) {	// key = /memberList.do 등의 경로 들어옴
		return mappings.get(key);		
	}
}
